/* ***********************************************************
 * This file was automatically generated on 2013-01-22.      *
 *                                                           *
 * Bindings Version 2.0.0                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/


#define IPCON_EXPOSE_INTERNALS

#include "bricklet_ptc.h"

#include <string.h>



typedef void (*TemperatureCallbackFunction)(int32_t, void *);

typedef void (*TemperatureReachedCallbackFunction)(int32_t, void *);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	PacketHeader header;
} ATTRIBUTE_PACKED GetTemperature_;

typedef struct {
	PacketHeader header;
	int32_t temperature;
} ATTRIBUTE_PACKED GetTemperatureResponse_;

typedef struct {
	PacketHeader header;
	uint32_t period;
} ATTRIBUTE_PACKED SetTemperatureCallbackPeriod_;

typedef struct {
	PacketHeader header;
} ATTRIBUTE_PACKED GetTemperatureCallbackPeriod_;

typedef struct {
	PacketHeader header;
	uint32_t period;
} ATTRIBUTE_PACKED GetTemperatureCallbackPeriodResponse_;

typedef struct {
	PacketHeader header;
	char option;
	int32_t min;
	int32_t max;
} ATTRIBUTE_PACKED SetTemperatureCallbackThreshold_;

typedef struct {
	PacketHeader header;
} ATTRIBUTE_PACKED GetTemperatureCallbackThreshold_;

typedef struct {
	PacketHeader header;
	char option;
	int32_t min;
	int32_t max;
} ATTRIBUTE_PACKED GetTemperatureCallbackThresholdResponse_;

typedef struct {
	PacketHeader header;
	uint32_t debounce;
} ATTRIBUTE_PACKED SetDebouncePeriod_;

typedef struct {
	PacketHeader header;
} ATTRIBUTE_PACKED GetDebouncePeriod_;

typedef struct {
	PacketHeader header;
	uint32_t debounce;
} ATTRIBUTE_PACKED GetDebouncePeriodResponse_;

typedef struct {
	PacketHeader header;
	int32_t temperature;
} ATTRIBUTE_PACKED TemperatureCallback_;

typedef struct {
	PacketHeader header;
	int32_t temperature;
} ATTRIBUTE_PACKED TemperatureReachedCallback_;

typedef struct {
	PacketHeader header;
} ATTRIBUTE_PACKED GetIdentity_;

typedef struct {
	PacketHeader header;
	char uid[8];
	char connected_uid[8];
	char position;
	uint8_t hardware_version[3];
	uint8_t firmware_version[3];
	uint16_t device_identifier;
} ATTRIBUTE_PACKED GetIdentityResponse_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

static void ptc_callback_wrapper_temperature(PTC *ptc, Packet *packet) {
	TemperatureCallbackFunction callback_function = (TemperatureCallbackFunction)ptc->registered_callbacks[PTC_CALLBACK_TEMPERATURE];
	void *user_data = ptc->registered_callback_user_data[PTC_CALLBACK_TEMPERATURE];
	TemperatureCallback_ *callback = (TemperatureCallback_ *)packet;

	callback->temperature = leconvert_int32_from(callback->temperature);

	if (callback_function != NULL) {
		callback_function(callback->temperature, user_data);
	}
}

static void ptc_callback_wrapper_temperature_reached(PTC *ptc, Packet *packet) {
	TemperatureReachedCallbackFunction callback_function = (TemperatureReachedCallbackFunction)ptc->registered_callbacks[PTC_CALLBACK_TEMPERATURE_REACHED];
	void *user_data = ptc->registered_callback_user_data[PTC_CALLBACK_TEMPERATURE_REACHED];
	TemperatureReachedCallback_ *callback = (TemperatureReachedCallback_ *)packet;

	callback->temperature = leconvert_int32_from(callback->temperature);

	if (callback_function != NULL) {
		callback_function(callback->temperature, user_data);
	}
}

void ptc_create(PTC *ptc, const char *uid, IPConnection *ipcon) {
	device_create(ptc, uid, ipcon, 2, 0, 0);

	ptc->response_expected[PTC_FUNCTION_GET_TEMPERATURE] = DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
	ptc->response_expected[PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = DEVICE_RESPONSE_EXPECTED_TRUE;
	ptc->response_expected[PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
	ptc->response_expected[PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = DEVICE_RESPONSE_EXPECTED_TRUE;
	ptc->response_expected[PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
	ptc->response_expected[PTC_FUNCTION_SET_DEBOUNCE_PERIOD] = DEVICE_RESPONSE_EXPECTED_TRUE;
	ptc->response_expected[PTC_FUNCTION_GET_DEBOUNCE_PERIOD] = DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
	ptc->response_expected[PTC_CALLBACK_TEMPERATURE] = DEVICE_RESPONSE_EXPECTED_ALWAYS_FALSE;
	ptc->response_expected[PTC_CALLBACK_TEMPERATURE_REACHED] = DEVICE_RESPONSE_EXPECTED_ALWAYS_FALSE;
	ptc->response_expected[PTC_FUNCTION_GET_IDENTITY] = DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

	ptc->callback_wrappers[PTC_CALLBACK_TEMPERATURE] = (void *)ptc_callback_wrapper_temperature;
	ptc->callback_wrappers[PTC_CALLBACK_TEMPERATURE_REACHED] = (void *)ptc_callback_wrapper_temperature_reached;
}

void ptc_destroy(PTC *ptc) {
	device_destroy(ptc);
}

int ptc_get_response_expected(PTC *ptc, uint8_t function_id, bool *ret_response_expected) {
	return device_get_response_expected(ptc, function_id, ret_response_expected);
}

int ptc_set_response_expected(PTC *ptc, uint8_t function_id, bool response_expected) {
	return device_set_response_expected(ptc, function_id, response_expected);
}

int ptc_set_response_expected_all(PTC *ptc, bool response_expected) {
	return device_set_response_expected_all(ptc, response_expected);
}

void ptc_register_callback(PTC *ptc, uint8_t id, void *callback, void *user_data) {
	device_register_callback(ptc, id, callback, user_data);
}

int ptc_get_api_version(PTC *ptc, uint8_t ret_api_version[3]) {
	return device_get_api_version(ptc, ret_api_version);
}

int ptc_get_temperature(PTC *ptc, int32_t *ret_temperature) {
	GetTemperature_ request;
	GetTemperatureResponse_ *response;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_GET_TEMPERATURE, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}


	ret = device_send_request(ptc, (Packet *)&request);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	response = (GetTemperatureResponse_ *)&ptc->response_packet;
	*ret_temperature = leconvert_int32_from(response->temperature);


	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_set_temperature_callback_period(PTC *ptc, uint32_t period) {
	SetTemperatureCallbackPeriod_ request;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	request.period = leconvert_uint32_to(period);

	ret = device_send_request(ptc, (Packet *)&request);

	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_get_temperature_callback_period(PTC *ptc, uint32_t *ret_period) {
	GetTemperatureCallbackPeriod_ request;
	GetTemperatureCallbackPeriodResponse_ *response;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}


	ret = device_send_request(ptc, (Packet *)&request);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	response = (GetTemperatureCallbackPeriodResponse_ *)&ptc->response_packet;
	*ret_period = leconvert_uint32_from(response->period);


	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_set_temperature_callback_threshold(PTC *ptc, char option, int32_t min, int32_t max) {
	SetTemperatureCallbackThreshold_ request;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	request.option = option;
	request.min = leconvert_int32_to(min);
	request.max = leconvert_int32_to(max);

	ret = device_send_request(ptc, (Packet *)&request);

	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_get_temperature_callback_threshold(PTC *ptc, char *ret_option, int32_t *ret_min, int32_t *ret_max) {
	GetTemperatureCallbackThreshold_ request;
	GetTemperatureCallbackThresholdResponse_ *response;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}


	ret = device_send_request(ptc, (Packet *)&request);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	response = (GetTemperatureCallbackThresholdResponse_ *)&ptc->response_packet;
	*ret_option = response->option;
	*ret_min = leconvert_int32_from(response->min);
	*ret_max = leconvert_int32_from(response->max);


	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_set_debounce_period(PTC *ptc, uint32_t debounce) {
	SetDebouncePeriod_ request;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_SET_DEBOUNCE_PERIOD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	request.debounce = leconvert_uint32_to(debounce);

	ret = device_send_request(ptc, (Packet *)&request);

	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_get_debounce_period(PTC *ptc, uint32_t *ret_debounce) {
	GetDebouncePeriod_ request;
	GetDebouncePeriodResponse_ *response;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_GET_DEBOUNCE_PERIOD, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}


	ret = device_send_request(ptc, (Packet *)&request);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	response = (GetDebouncePeriodResponse_ *)&ptc->response_packet;
	*ret_debounce = leconvert_uint32_from(response->debounce);


	mutex_unlock(&ptc->request_mutex);

	return ret;
}

int ptc_get_identity(PTC *ptc, char ret_uid[8], char ret_connected_uid[8], char *ret_position, uint8_t ret_hardware_version[3], uint8_t ret_firmware_version[3], uint16_t *ret_device_identifier) {
	GetIdentity_ request;
	GetIdentityResponse_ *response;
	int ret;

	mutex_lock(&ptc->request_mutex);

	ret = packet_header_create(&request.header, sizeof(request), PTC_FUNCTION_GET_IDENTITY, ptc->ipcon, ptc);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}


	ret = device_send_request(ptc, (Packet *)&request);

	if (ret < 0) {
		mutex_unlock(&ptc->request_mutex);

		return ret;
	}

	response = (GetIdentityResponse_ *)&ptc->response_packet;
	strncpy(ret_uid, response->uid, 8);
	strncpy(ret_connected_uid, response->connected_uid, 8);
	*ret_position = response->position;
	memcpy(ret_hardware_version, response->hardware_version, 3 * sizeof(uint8_t));
	memcpy(ret_firmware_version, response->firmware_version, 3 * sizeof(uint8_t));
	*ret_device_identifier = leconvert_uint16_from(response->device_identifier);


	mutex_unlock(&ptc->request_mutex);

	return ret;
}
